SystemOrganization addCategory: #ConfigurationOfHPDF!

Object subclass: #ConfigurationOfHPDF
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfHPDF'!

!ConfigurationOfHPDF class methodsFor: 'private' stamp: 'tbn 1/21/2010 09:05'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfHPDF class methodsFor: 'private' stamp: 'tbn 1/21/2010 09:05'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfHPDF class methodsFor: 'metacello tool support' stamp: 'tbn 1/21/2010 09:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfHPDF class methodsFor: 'metacello tool support' stamp: 'tbn 1/21/2010 09:05'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfHPDF class methodsFor: 'loading' stamp: 'tbn 1/21/2010 09:06'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfHPDF class methodsFor: 'metacello tool support' stamp: 'tbn 1/21/2010 09:06'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfHPDF class methodsFor: 'accessing' stamp: 'tbn 1/21/2010 09:06'!
project

	^self new project! !

!ConfigurationOfHPDF methodsFor: 'baselines' stamp: 'tbn 1/21/2010 09:11'!
baseline10: spec
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: 'Initial baseline for HPDF'.
		spec repository: 'http://www.squeaksource.com/HPDF' ].
	
	spec for: #squeakCommon do: [
		spec
			repository: 'http://www.squeaksource.com/HPDF';
			package: 'HPDF' with: [ spec requires: #('FFI' )].
		 spec
			project: 'FFI' with: [
				spec
					className: 'ConfigurationOfFFI';
					file: 'ConfigurationOfFFI';	
					version: '1.0-baseline';			 
					repository: 'http://www.squeaksource.com/MetacelloRepository' ]	 
	].			 
	
	spec for: #common do: [
		spec
			group: 'default' with: 'HPDF' ].  ! !

!ConfigurationOfHPDF methodsFor: 'accessing' stamp: 'tbn 1/21/2010 09:00'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfHPDF methodsFor: 'versions' stamp: 'tbn 2/18/2010 00:08'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'First release'. 
		spec author: 'Torsten Bergmann'.
		spec timestamp: '1/21/2010 8:49'.
		spec 
			project: 'FFI' with: '1.0'.
		spec package: 'HPDF' with: 'HPDF-tbn.26'.
	]! !

!ConfigurationOfHPDF methodsFor: 'versions' stamp: 'tbn 2/18/2010 00:09'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'First release'. 
		spec author: 'Torsten Bergmann'.
		spec timestamp: '2/18/2010 8:49'.
		spec 
			project: 'FFI' with: '1.2'.
		spec package: 'HPDF' with: 'HPDF-tbn.26'.
	]! !
